function message (msg) {
    const e = document.createElement('div');
    e.textContent = msg;
    document.getElementById('inn').appendChild(e);
}

function updateLuminance () {
  const e = document.getElementById('inn');
  e.style.background = `rgb(${luminance}, ${luminance}, ${luminance})`;
}


let keyboard = {
    enter: false
};

let luminance = 255;

function* waitInput() {
    var startMs = Date.now();
    const perFrame = 16;
    let diffTime = 0;
    
    keyboard.enter = false;
    while (!keyboard.enter) {      
        diffTime = Date.now() - startMs;    
        const e = document.getElementById('inn');
        e.classList.remove('showCursor');
        
        if (diffTime % 1000 < 500) {
            e.classList.add('showCursor');
        }       
        
        yield undefined;
    }
    keyboard.enter = false;
}

function* waitFadeOut() {
    while (luminance > 0) { 
        luminance -= 5;
        updateLuminance();
        yield undefined;
    }
    luminance = 0;
    updateLuminance();
}

function* waitFadeIn() {
    while (luminance < 255) { 
        luminance += 5;
        updateLuminance();
        yield undefined;
    }
    luminance = 255;
    updateLuminance();
}

window.onload = function() {   
    var lastFrameTime = Date.now();
    function nextFrame() {
        var thisFrameTime = Date.now();
        var deltaTime = thisFrameTime - lastFrameTime;
        lastFrameTime = thisFrameTime;
        babysitter.update(deltaTime);
        requestAnimationFrame(nextFrame);
    }
    nextFrame();
          
    babysitter.add(function*(dt) {
        updateLuminance();
        dt = yield undefined;
        message('안녕하세요. 게임을 시작 할려면'); 
        message('"Enter"키를 눌러 주세요!!!');
        dt = yield* waitInput();  
        dt = yield* waitFadeOut();
        dt = yield* waitFadeIn();
        message('당신은 마법사로 단군 조선을 구해야 합니다.');        
        dt = yield* waitInput();
    });
}

var onKeyEvent = function(e) {
    if(e.key === 'Enter') {
        keyboard.enter = true;
    } 
} 

document.addEventListener("keydown", onKeyEvent);